\ Data stack tester

s" " max-results new-tester \ no stack id for data stack.

#results: #cell-results
create cell-results[] max-results 2* cells allot
: cell-results ( flag.which -- addr )
	[ max-results cells ] literal and cell-results[] + ;
: cell-result ( u flag.which -- addr )
	cell-results swap cells + ;

\ U.CELLS is the number of cells consumed.
: cell-result= ( u -- flag u.cells )
	dup expected cell-result @
	swap received cell-result @ =  1 ;
: .cell-result ( u flag.which -- u.cells )
	cell-result @ .  1 ;

variable depth0
: cell-depth ( -- n )  depth depth0 @ - ;
: begin-cells ( -- )  depth depth0 !
	['] cell-result= ['] .cell-result
	max-results default-types ;
' begin-cells begin-test-xt !
test-types constant cell-types
: cell-type ( xt.test xt.print -- )
	cell-types cell-depth 3 -  2* cells + tuck cell+ ! ! ;

base @ hex DEFACED constant defaced base !
: save-cells ( ... flag.which -- )
	>r cell-depth r>  2dup #cell-results !
	over 0> if cell-results swap
		1- cells over + do  i !  -1 cells +loop
	else drop negate 0 ?do defaced loop then ;
' save-cells save-stack-xt !


( unsigned type )

[undefined] hex. [if]
: hex. ( u -- )  base @ hex [char] $ emit swap u. base ! ;
[then]

: .ucell-result ( u flag.which -- u.cells )
	cell-result @ u.  1 ;
: .xcell-result ( u flag.which -- u.cells )
	cell-result @ hex.  1 ;
: U: ( -- )  ['] cell-result= ['] .ucell-result cell-type ;
: X: ( -- )  ['] cell-result= ['] .xcell-result cell-type ;

base @ hex DEADBEEF constant DEADBEEF base !
: don't-care ( u -- flag u.cells )  drop true 1 ;
: ?? ( -- x )
	['] don't-care ['] .xcell-result cell-type  DEADBEEF ;


( string type )

[undefined] str= [if] : str= compare 0= ; [then]

32 constant max-quoted
: quote ( c-addr u -- )
	[char] " emit
	dup 0< if 2drop here 0 else
	dup max-quoted u> if drop max-quoted type s" ..."
	then then type [char] " emit ;

: string-result= ( u -- flag u.step )
	dup received cell-result 2@ swap
	rot expected cell-result 2@ swap str=  2 ;
: .string-result ( u flag.which -- u.step )
	cell-result 2@ swap
	over hex. dup u.  ." (" quote ." ) "  2 ;
: S: ( -- )  ['] string-result= ['] .string-result cell-type ;

\ TODO - don't ALLOT, use a circular buffer instead
: T" ( "...<quote>" -- c-addr u )  S: [char] " parse allot-chars ;
